【LeetCode】239. Sliding Window Maximum 滑动窗口最大值(Hard)(JAVA)
题目地址: https://leetcode.com/problems/sliding-window-maximum/
题目描述:
You are given an array of integers nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position.
Return the max sliding window.
Example 1:
Input: nums = [1,3,-1,-3,5,3,6,7], k = 3
Output: [3,3,5,5,6,7]
Explanation:
Window position Max
--------------- -----
[1 3 -1] -3 5 3 6 7 3
1 [3 -1 -3] 5 3 6 7 3
1 3 [-1 -3 5] 3 6 7 5
1 3 -1 [-3 5 3] 6 7 5
1 3 -1 -3 [5 3 6] 7 6
1 3 -1 -3 5 [3 6 7] 7
Example 2:
Input: nums = [1], k = 1
Output: [1]
Example 3:
Input: nums = [1,-1], k = 1
Output: [1,-1]
Example 4:
Input: nums = [9,11], k = 2
Output: [11]
Example 5:
Input: nums = [4,-2], k = 2
Output: [4]
Constraints:
- 1 <= nums.length <= 10^5
- -10^4 <= nums[i] <= 10^4
- 1 <= k <= nums.length
题目大意
给定一个数组 nums,有一个大小为 k 的滑动窗口从数组的最左侧移动到数组的最右侧。你只可以看到在滑动窗口内的 k 个数字。滑动窗口每次只向右移动一位。
返回滑动窗口中的最大值。
进阶:
你能在线性时间复杂度内解决此题吗?
解题方法
- 要时间复杂度是 O(n) 肯定不能使用暴力的方法,暴力的方法时间复杂度为 O(kn)
- 采用双向队列的方式,把最大值存入队列中的最前面,每次存入值前把队列最后把比当前值小的值都去掉了,这样队列里就是按照从大到小排序的了(这里采用 LinkedList )
- 窗口滑动的时候,需要上一个窗口最前面的值去掉,如果去掉的值刚好是队列最前面的值,也就是最大值,也需要把队列前面的值去掉,然后取到队列最前面的值的就是当前窗口的最大值了
class Solution {
public int[] maxSlidingWindow(int[] nums, int k) {
if (k == 1) return nums;
int[] res = new int[nums.length - k + 1];
LinkedList<Integer> list = new LinkedList<>();
for (int i = 0; i < nums.length; i++) {
if (i >= k && nums[i - k] == list.get(0)) list.removeFirst();
while (list.size() > 0 && list.getLast() < nums[i]) {
list.removeLast();
}
list.add(nums[i]);
if (i >= k - 1) res[i - k + 1] = list.get(0);
}
return res;
}
}
执行耗时:34 ms,击败了57.94% 的Java用户
内存消耗:50 MB,击败了72.20% 的Java用户